/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { RangeCategorySeries } from "./RangeCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { Axis } from "./Axis";
import { Point_$type, runOn, typeCast, markType, markDep } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { RangeValueList } from "./RangeValueList";
import { ScalerParams } from "./ScalerParams";
import { CategoryXAxis } from "./CategoryXAxis";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
/**
 * @hidden
 */
var HorizontalRangeCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HorizontalRangeCategorySeries, _super);
    function HorizontalRangeCategorySeries() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HorizontalRangeCategorySeries.prototype.fetchXAxis = function () {
        return this.xAxis;
    };
    HorizontalRangeCategorySeries.prototype.fetchYAxis = function () {
        return this.yAxis;
    };
    HorizontalRangeCategorySeries.prototype.oz = function () {
        _super.prototype.oz.call(this);
        this.xAxis = null;
        this.yAxis = null;
    };
    HorizontalRangeCategorySeries.prototype.aj = function (a) {
        var b = this.am(this.yj(), this.yk.f, this.zl(this.ct), this.zm(this.ct), this.wa(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[2] };
        f[1] = { $type: Point_$type, x: d[0], y: d[2] };
        e[0] = f;
        return e;
    };
    HorizontalRangeCategorySeries.prototype.ak = function (a) {
        var b = this.am(this.yj(), this.yk.f, this.zl(this.ct), this.zm(this.ct), this.wa(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    };
    HorizontalRangeCategorySeries.prototype.get_fs = function () {
        return true;
    };
    HorizontalRangeCategorySeries.prototype.b0 = function () {
        if (this.b1 == 0) {
            return 1;
        }
        else {
            return _super.prototype.b0.call(this);
        }
    };
    HorizontalRangeCategorySeries.prototype.getOffsetValue = function () {
        return this.RangeFramePreparer.r(this.xAxis, this.ct.by, this.ct.bx, this.getEffectiveViewport1(this.ct));
    };
    HorizontalRangeCategorySeries.prototype.getCategoryWidth = function () {
        return this.xAxis.getCategorySize(this.ct.by, this.ct.bx, this.getEffectiveViewport1(this.ct));
    };
    HorizontalRangeCategorySeries.prototype.j6 = function (a, b) {
        return this.j7(a, b, this.xAxis, runOn(this, this.zj), new RangeValueList(this.highColumn, this.lowColumn));
    };
    HorizontalRangeCategorySeries.prototype.j8 = function (a, b) {
        return this.j9(a, b, this.xAxis, runOn(this, this.zj), new RangeValueList(this.highColumn, this.lowColumn));
    };
    HorizontalRangeCategorySeries.prototype.im = function (a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        var f = this.xAxis.lg;
        return this.io(a, b, this.xAxis, d, e, f, runOn(this, this.zj));
    };
    HorizontalRangeCategorySeries.prototype.i3 = function (a, b, c) {
        if (this.c9 == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.ct);
        var e = new ScalerParams(0, this.c9.vl, this.ct.bx, this.xAxis.ch, d);
        var f = this.RangeFramePreparer.r(this.xAxis, this.c9.vl, this.ct.bx, d);
        return this.i5(new RangeValueList(this.highColumn, this.lowColumn), a, this.xAxis, e, f, runOn(this, this.zj), b, c);
    };
    HorizontalRangeCategorySeries.prototype.i1 = function (a, b, c) {
        if (this.c9 == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.ct);
        var e = new ScalerParams(0, this.c9.vl, this.ct.bx, this.xAxis.ch, d);
        var f = this.RangeFramePreparer.r(this.xAxis, this.c9.vl, this.ct.bx, d);
        return this.i5(this.lowColumn, a, this.xAxis, e, f, runOn(this, this.zj), b, c);
    };
    HorizontalRangeCategorySeries.prototype.iz = function (a, b, c) {
        if (this.c9 == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.ct);
        var e = new ScalerParams(0, this.c9.vl, this.ct.bx, this.xAxis.ch, d);
        var f = this.RangeFramePreparer.r(this.xAxis, this.c9.vl, this.ct.bx, d);
        return this.i5(this.highColumn, a, this.xAxis, e, f, runOn(this, this.zj), b, c);
    };
    HorizontalRangeCategorySeries.prototype.v1 = function (a, b, c) {
        var _this = this;
        return this.v7(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.ct.by, this.ct.bx, this.getEffectiveViewport1(this.ct)), this.yAxis, this.xAxis, runOn(this, this.iz), function (d, e) { return _this.j9(d, e, _this.xAxis, runOn(_this, _this.zj), _this.highColumn); }, function (d, e) { return _this.j7(d, e, _this.xAxis, runOn(_this, _this.zj), _this.highColumn); });
    };
    HorizontalRangeCategorySeries.prototype.v3 = function (a, b, c) {
        var _this = this;
        return this.v7(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.ct.by, this.ct.bx, this.getEffectiveViewport1(this.ct)), this.yAxis, this.xAxis, runOn(this, this.i1), function (d, e) { return _this.j9(d, e, _this.xAxis, runOn(_this, _this.zj), _this.lowColumn); }, function (d, e) { return _this.j7(d, e, _this.xAxis, runOn(_this, _this.zj), _this.lowColumn); });
    };
    HorizontalRangeCategorySeries.prototype.v5 = function (a, b, c) {
        return this.v7(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.ct.by, this.ct.bx, this.getEffectiveViewport1(this.ct)), this.yAxis, this.xAxis, null, null, null);
    };
    HorizontalRangeCategorySeries.prototype.zf = function () {
        return this.yAxis != null && this.yAxis.c1();
    };
    HorizontalRangeCategorySeries.prototype.q4 = function (a, b, c, d) {
        _super.prototype.q4.call(this, a, b, c, d);
        switch (b) {
            case HorizontalRangeCategorySeries.$$p[0]:
            case HorizontalRangeCategorySeries.$$p[1]:
            case HorizontalRangeCategorySeries.$$p[2]:
            case HorizontalRangeCategorySeries.$$p[3]:
                this.qa();
                break;
            case HorizontalRangeCategorySeries.$$p[4]:
                this.o9(typeCast(Axis.$, c));
                this.rc(typeCast(Axis.$, d));
                this.yt.cw.g(this.ib);
                this.rm(false);
                this.qg();
                break;
            case HorizontalRangeCategorySeries.$$p[5]:
                this.o9(typeCast(Axis.$, c));
                this.rc(typeCast(Axis.$, d));
                this.yt.cw.g(this.ib);
                this.zf();
                this.rm(false);
                this.qg();
                break;
        }
    };
    HorizontalRangeCategorySeries.prototype.aa1 = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    HorizontalRangeCategorySeries.prototype.aa0 = function (a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.ce) {
            return true;
        }
        return false;
    };
    HorizontalRangeCategorySeries.prototype.getDataLegendSeriesContextAt = function (a, b) {
        var c = { $type: Point_$type, x: a, y: b };
        var d = this.i1(c, false, false);
        var e = this.iz(c, false, false);
        var f = new DataLegendSeriesValueInfo();
        f.a = 1;
        f.l = e > d ? d : e;
        f.q = "Low";
        f.r = this.aap != null ? this.aap : "Low";
        f.s = this.aa6 != null ? this.aa6 : "L:";
        f.t = this.aa8 != null ? this.aa8 : "";
        var g = new DataLegendSeriesValueInfo();
        g.a = 2;
        g.l = e > d ? e : d;
        g.q = "High";
        g.r = this.aam != null ? this.aam : "High";
        g.s = this.aa2 != null ? this.aa2 : "H:";
        g.t = this.aa4 != null ? this.aa4 : "";
        var h = new DataLegendSeriesValueInfo();
        h.a = 7;
        h.l = Math.abs(g.l - f.l);
        h.q = "Range";
        h.r = "Range";
        h.s = "R:";
        h.k = true;
        var i = new DataLegendSeriesValueInfo();
        i.a = 6;
        i.l = f.l + (h.l / 2);
        i.q = "Average";
        i.r = "Average";
        i.s = "A:";
        i.k = true;
        var j = new DataLegendSeriesContext();
        j.e = ((function () {
            var $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
            $ret.add(g);
            $ret.add(f);
            $ret.add(h);
            $ret.add(i);
            return $ret;
        })());
        j.h = this.l9();
        return j;
    };
    Object.defineProperty(HorizontalRangeCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.zg;
        },
        enumerable: false,
        configurable: true
    });
    HorizontalRangeCategorySeries.$t = markType(HorizontalRangeCategorySeries, 'HorizontalRangeCategorySeries', RangeCategorySeries.$);
    HorizontalRangeCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, HorizontalRangeCategorySeries, 'raisePropertyChanged', ['HighMemberAsLegendLabel:aa2:abc', [2, null], 'HighMemberAsLegendUnit:aa4:abd', [2, null], 'LowMemberAsLegendLabel:aa6:abe', [2, null], 'LowMemberAsLegendUnit:aa8:abf', [2, null], 'XAxis::abg', [CategoryAxisBase.$, null], 'YAxis::abh', [NumericYAxis.$, null]]);
    return HorizontalRangeCategorySeries;
}(RangeCategorySeries));
export { HorizontalRangeCategorySeries };
